## tightgatevnc-clientonly 4.8.0~aatgv2

=== CMakeLists.txt ===
#
# Setup
#

cmake_minimum_required(VERSION 2.8.11)

# Internal cmake modules
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/Modules)

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckLibraryExists)
include(CheckTypeSize)
include(CheckCSourceCompiles)
include(CheckCXXSourceCompiles)
include(CheckCSourceRuns)

include(CMakeMacroLibtoolFile)

project(tigervnc)
set(VERSION 4.8.0)

# The RC version must always be four comma-separated numbers
set(RCVERSION 4,8,0)

# Installation paths
include(GNUInstallDirs)
set(CMAKE_INSTALL_UNITDIR "lib/systemd/system" CACHE PATH "systemd unit files (lib/systemd/system)")
if(IS_ABSOLUTE "${CMAKE_INSTALL_UNITDIR}")
  set(CMAKE_INSTALL_FULL_UNITDIR "${CMAKE_INSTALL_UNITDIR}")
else()
  set(CMAKE_INSTALL_FULL_UNITDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_UNITDIR}")
endif()

option(INSTALL_SYSTEMD_UNITS "Install TigerVNC systemd units" ON)

if(MSVC)
  message(FATAL_ERROR "TigerVNC cannot be built with Visual Studio.  Please use MinGW")
endif()

if(NOT BUILD_TIMESTAMP)
  STRING(TIMESTAMP BUILD_TIMESTAMP "%Y-%m-%d %H:%M" UTC)
endif()

# Default to optimised builds instead of debug ones. Our code has no bugs ;)
# (CMake makes it fairly easy to toggle this back to Debug if needed)
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

message(STATUS "CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}")

message(STATUS "VERSION = ${VERSION}")
message(STATUS "BUILD_TIMESTAMP = ${BUILD_TIMESTAMP}")
add_definitions(-DBUILD_TIMESTAMP="${BUILD_TIMESTAMP}")

# We want to keep our asserts even in release builds so remove NDEBUG
set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -UNDEBUG")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -UNDEBUG")
set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO} -UNDEBUG")
set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -UNDEBUG")
set(CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} -UNDEBUG")
set(CMAKE_CXX_FLAGS_MINSIZEREL "${CMAKE_CXX_FLAGS_MINSIZEREL} -UNDEBUG")

# Make sure we get a sane C version
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")

# Tell the compiler to be stringent
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wformat=2")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wformat=2")
# Make sure we catch these issues whilst developing
IF(CMAKE_BUILD_TYPE MATCHES Debug)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror -Werror=vla")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror -Werror=vla")
ENDIF()

option(ENABLE_ASAN "Enable address sanitizer support" OFF)
if(ENABLE_ASAN AND NOT WIN32 AND NOT APPLE)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
endif()

option(ENABLE_TSAN "Enable thread sanitizer support" OFF)
if(ENABLE_TSAN AND NOT WIN32 AND NOT APPLE AND CMAKE_SIZEOF_VOID_P MATCHES 8)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=thread")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=thread")
endif()

#if(NOT DEFINED BUILD_WINVNC)
#  set(BUILD_WINVNC 1)
#endif()

# Minimum version is Windows 7
if(WIN32)
  add_definitions(-D_WIN32_WINNT=0x0601)
endif()

# Legacy macros (macOS 10.12 and older) conflict with our code
if(APPLE)
  add_definitions(-D__ASSERT_MACROS_DEFINE_VERSIONS_WITHOUT_UNDERSCORES=0)
endif()

if(CMAKE_SIZEOF_VOID_P MATCHES 8)
  message(STATUS "64-bit build")
else()
  message(STATUS "32-bit build")
endif()

# Versions of CMake before 2.8.7 do not properly support resource compilation
# with MinGW.  Boo!
if(MINGW AND "${CMAKE_VERSION}" VERSION_LESS "2.8.7")
  if(NOT DEFINED RC)
    set(CMAKE_RC_COMPILER_INIT windres)
  else()
    set(CMAKE_RC_COMPILER_INIT ${RC})
  endif()
  enable_language(RC)
  message(STATUS "Resource compiler: ${CMAKE_RC_COMPILER}")
  set(CMAKE_RC_COMPILE_OBJECT
    "<CMAKE_RC_COMPILER> <FLAGS> <DEFINES> -o <OBJECT> --output-format=coff <SOURCE>")
endif()

# MinGW64 has header support but no library support for IActiveDesktop, so we
# need to check for both the header and library and use our own implementation
# in common/os if either doesn't exist.
if(WIN32)
  check_c_source_compiles("#include <windows.h>\n#include <wininet.h>\n#include <shlobj.h>\nint main(int c, char** v) {IActiveDesktop iad; (void)iad; return 0;}" HAVE_ACTIVE_DESKTOP_H)
  check_c_source_compiles("#include <windows.h>\n#include <wininet.h>\n#include <shlobj.h>\nint main(int c, char** v) {GUID i = CLSID_ActiveDesktop; (void)i; return 0;}" HAVE_ACTIVE_DESKTOP_L)
endif()

# X11 stuff. It's in a if() so that we can say REQUIRED
if(UNIX AND NOT APPLE)
  find_package(X11 REQUIRED)
endif()

# Check for zlib
find_package(ZLIB REQUIRED)

# Check for pixman
find_package(Pixman REQUIRED)

# Check for gettext
option(ENABLE_NLS "Enable translation of program messages" ON)
if(ENABLE_NLS)
  # Tools
  find_package(Gettext)

  # Gettext needs iconv
  find_package(Iconv)

  if(ICONV_FOUND)
    # Headers and libraries (copied from licq)
    set(GETTEXT_FOUND FALSE)

    find_path(GETTEXT_INCLUDE_DIR libintl.h)
    if(GETTEXT_INCLUDE_DIR)
      set(CMAKE_REQUIRED_LIBRARIES ${ICONV_LIBRARIES})
      set(CMAKE_REQUIRED_FLAGS -fno-builtin-dgettext)
      check_function_exists(dgettext LIBC_HAS_DGETTEXT)
      if(LIBC_HAS_DGETTEXT)
        set(GETTEXT_FOUND TRUE)
      else()
        find_library(LIBINTL_LIBRARY NAMES intl libintl)
        if(LIBINTL_LIBRARY)
          check_library_exists(${LIBINTL_LIBRARY} "dgettext" "" LIBINTL_HAS_DGETTEXT)
          if(LIBINTL_HAS_DGETTEXT)
            set(GETTEXT_LIBRARIES ${LIBINTL_LIBRARY} ${ICONV_LIBRARIES})
            set(GETTEXT_FOUND TRUE)
          endif()
        endif()
      endif()
      set(CMAKE_REQUIRED_LIBRARIES)
      set(CMAKE_REQUIRED_FLAGS)
    endif()
  endif()

  if(NOT GETTEXT_FOUND OR NOT ICONV_FOUND)
    message(WARNING "Gettext NOT found.  Native Language Support disabled.")
    set(ENABLE_NLS 0)
  endif()
endif()

# Check for libjpeg
find_package(JPEG REQUIRED)

# Warn if it doesn't seem to be the accelerated libjpeg that's found
set(CMAKE_REQUIRED_LIBRARIES ${JPEG_LIBRARIES})
set(CMAKE_REQUIRED_FLAGS -I${JPEG_INCLUDE_DIR})
if (NOT APPLE)
  set(CMAKE_REQUIRED_FLAGS -I/usr/include/glib-2.0 -I/usr/lib/x86_64-linux-gnu/glib-2.0/include)
endif()

set(JPEG_TEST_SOURCE "\n
  #include <stdio.h>\n
  #include <jpeglib.h>\n
  int main(void) {\n
    struct jpeg_compress_struct cinfo;\n
    struct jpeg_error_mgr jerr;\n
    cinfo.err=jpeg_std_error(&jerr);\n
    jpeg_create_compress(&cinfo);\n
    cinfo.input_components = 3;\n
    jpeg_set_defaults(&cinfo);\n
    cinfo.in_color_space = JCS_EXT_RGB;\n
    jpeg_default_colorspace(&cinfo);\n
    return 0;\n
  }")

if(CMAKE_CROSSCOMPILING)
  check_c_source_compiles("${JPEG_TEST_SOURCE}" FOUND_LIBJPEG_TURBO)
else()
  check_c_source_runs("${JPEG_TEST_SOURCE}" FOUND_LIBJPEG_TURBO)
endif()

set(CMAKE_REQUIRED_LIBRARIES)
set(CMAKE_REQUIRED_FLAGS)
set(CMAKE_REQUIRED_DEFINITIONS)

if(NOT FOUND_LIBJPEG_TURBO)
  message(STATUS "WARNING: You are not using libjpeg-turbo. Performance will suffer.")
endif()

if (NOT APPLE)
  include_directories(${JPEG_INCLUDE_DIR} /usr/include/glib-2.0 /usr/lib/x86_64-linux-gnu/glib-2.0/include)
endif()

option(BUILD_JAVA "Build Java version of the TigerVNC Viewer" FALSE)
if(BUILD_JAVA)
  add_subdirectory(java)
endif()

# Check for FLTK
set(FLTK_SKIP_FLUID TRUE)
set(FLTK_SKIP_OPENGL TRUE)
set(FLTK_SKIP_FORMS TRUE)
find_package(FLTK)

if(UNIX AND NOT APPLE)
  # No proper handling for extra X11 libs that FLTK might need...
  if(X11_Xft_FOUND)
    # Xft headers include references to fontconfig, so we need
    # to link to that as well
    find_library(FONTCONFIG_LIB fontconfig)
    set(FLTK_LIBRARIES ${FLTK_LIBRARIES} ${X11_Xft_LIB} ${FONTCONFIG_LIB})
  endif()
  if(X11_Xinerama_FOUND)
    set(FLTK_LIBRARIES ${FLTK_LIBRARIES} ${X11_Xinerama_LIB})
  endif()
  if(X11_Xfixes_FOUND)
    set(FLTK_LIBRARIES ${FLTK_LIBRARIES} ${X11_Xfixes_LIB})
  endif()
  if(X11_Xcursor_FOUND)
    set(FLTK_LIBRARIES ${FLTK_LIBRARIES} ${X11_Xcursor_LIB})
  endif()
  if(X11_Xrender_FOUND)
    set(FLTK_LIBRARIES ${FLTK_LIBRARIES} ${X11_Xrender_LIB})
  endif()
endif()

# Check for GNUTLS library
option(ENABLE_GNUTLS "Enable protocol encryption and advanced authentication" ON)
if(ENABLE_GNUTLS)
  find_package(GnuTLS)
  if (GNUTLS_FOUND)
    include_directories(${GNUTLS_INCLUDE_DIR})
    add_definitions("-DHAVE_GNUTLS")
    add_definitions(${GNUTLS_DEFINITIONS})
  endif()
endif()

# Check for PAM library
if(UNIX AND NOT APPLE)
  check_include_files(security/pam_appl.h HAVE_PAM_H)
  set(CMAKE_REQUIRED_LIBRARIES -lpam)
  check_function_exists(pam_start HAVE_PAM_START)
  set(CMAKE_REQUIRED_LIBRARIES)
  if(HAVE_PAM_H AND HAVE_PAM_START)
    set(PAM_LIBS pam)
  else()
    message(FATAL_ERROR "Could not find PAM development files")
  endif()
endif()

# Check for socket functions
if(WIN32)
  set(CMAKE_EXTRA_INCLUDE_FILES winsock2.h ws2tcpip.h)
  # check_function_exists() cannot handle stdcall, so just define things
  set(HAVE_INET_ATON 1)
  set(HAVE_GETADDRINFO 1)
else()
  check_function_exists(inet_aton HAVE_INET_ATON)
  check_function_exists(getaddrinfo HAVE_GETADDRINFO)
  set(CMAKE_REQUIRED_LIBRARIES)
  set(CMAKE_EXTRA_INCLUDE_FILES sys/socket.h)
endif()
check_function_exists(inet_aton HAVE_INET_ATON)
check_function_exists(getaddrinfo HAVE_GETADDRINFO)
set(CMAKE_EXTRA_INCLUDE_FILES)
set(CMAKE_REQUIRED_LIBRARIES)

check_function_exists(gettid HAVE_GETTID)

# Generate config.h and make sure the source finds it
configure_file(config.h.in config.h)
add_definitions(-DHAVE_CONFIG_H)
include_directories(${CMAKE_BINARY_DIR})

include(cmake/StaticBuild.cmake)

add_subdirectory(common)

if(WIN32)
  add_subdirectory(win)
else()
  # No interest in building x related parts on Apple
  if(NOT APPLE)
    add_subdirectory(unix)
  endif()
endif()

if(ENABLE_NLS)
  add_subdirectory(po)
endif()

option(BUILD_VIEWER "Build TigerVNC viewer" ON)
if(BUILD_VIEWER)
  add_subdirectory(vncviewer)
  add_subdirectory(media)
endif()

add_subdirectory(tests)


add_subdirectory(release)

# uninstall
configure_file("${CMAKE_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
  "cmake_uninstall.cmake" IMMEDIATE @ONLY)

add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P cmake_uninstall.cmake)

=== java/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)

project(tigervnc-java Java)
if(NOT VERSION)
  set(VERSION 1.11.80)
endif()

find_package(Java)

set(DEFAULT_JAVACFLAGS "-source 8 -target 8 -encoding UTF-8 -Xlint:all,-serial,-cast,-unchecked,-fallthrough,-dep-ann,-deprecation,-rawtypes")
set(JAVACFLAGS ${DEFAULT_JAVACFLAGS} CACHE STRING
  "Java compiler flags (Default: ${DEFAULT_JAVACFLAGS})")
message(STATUS "Java compiler flags = ${JAVACFLAGS}")

set(CLASSPATH com/tigervnc/vncviewer)
set(SRCDIR ${CMAKE_CURRENT_SOURCE_DIR})
set(BINDIR ${CMAKE_CURRENT_BINARY_DIR})
set(JAVA_KEYSTORE NOTFOUND CACHE STRING "URL of keystore location")
set(JAVA_KEYSTORE_TYPE "jks" CACHE STRING "Type of keystore (Default: \"jks\")")
set(JAVA_KEY_ALIAS NOTFOUND CACHE STRING "Alias for the keystore entry used to generate the signature")
set(JAVA_STOREPASS NOTFOUND CACHE STRING "Password required to access the keystore")
set(JAVA_KEYPASS NOTFOUND CACHE STRING "Password used to protect the private key of the specified keystore entry")
set(JAVA_TSA_URL NOTFOUND CACHE STRING "URL of Time Stamping Authority (TSA)")

if(NOT BUILD)
	STRING(TIMESTAMP BUILD "%Y%m%d" UTC)
endif()
STRING(TIMESTAMP JAVA_DATE "%Y-%m-%d" UTC)
STRING(TIMESTAMP JAVA_TIME "%H:%M:%S" UTC)

set(JAVA_SOURCES "")
set(JAVA_CLASSES "")

set(JSCH_CLASSNAMES
  DH
  DHEC256
  DHEC384
  DHEC521
  DHECN
  DHGEX256
  DHG1
  DHG14
  DHGEX
  ECDH
  JSch
  Session
  UserAuth
  UserAuthKeyboardInteractive
  UserAuthPassword
  UserAuthPublicKey
  UserAuthNone
  jce/AES128CBC
  jce/AES128CTR
  jce/AES192CBC
  jce/AES192CTR
  jce/AES256CBC
  jce/AES256CTR
  jce/ARCFOUR
  jce/ARCFOUR128
  jce/ARCFOUR256
  jce/BlowfishCBC
  jce/DH
	jce/ECDH256
	jce/ECDH384
	jce/ECDH521
	jce/ECDHN
  jce/HMAC
  jce/HMACMD5
  jce/HMACMD596
  jce/HMACSHA1
  jce/HMACSHA196
  jce/HMACSHA256
  jce/HMACSHA512
  jce/KeyPairGenDSA
  jce/KeyPairGenECDSA
  jce/KeyPairGenRSA
  jce/MD5
  jce/PBKDF
  jce/Random
  jce/SHA1
  jce/SHA256
  jce/SHA384
  jce/SHA512
  jce/SignatureDSA
  jce/SignatureECDSA
  jce/SignatureRSA
  jce/TripleDESCBC
  jce/TripleDESCTR
  jcraft/Compression
  jcraft/HMAC
  jcraft/HMACMD596
  jcraft/HMACMD5
  jcraft/HMACSHA196
  jcraft/HMACSHA1)

foreach(class ${JSCH_CLASSNAMES})
  set(JAVA_SOURCES ${JAVA_SOURCES} com/jcraft/jsch/${class}.java)
  set(JAVA_CLASSES ${JAVA_CLASSES}
    ${BINDIR}/com/jcraft/jsch/${class}.class)
endforeach()

file(GLOB DEPEND_SOURCES
  ${SRCDIR}/${CLASSPATH}/*.java
  ${SRCDIR}/com/tigervnc/rfb/*.java
  ${SRCDIR}/com/tigervnc/rdr/*.java
  ${SRCDIR}/com/tigervnc/network/*.java
  ${SRCDIR}/com/jcraft/jsch/*.java
  ${SRCDIR}/com/jcraft/jsch/jcraft/*.java
  ${SRCDIR}/com/jcraft/jsch/jgss/*.java
  ${SRCDIR}/com/jcraft/jzlib/*.java)

string(REGEX REPLACE " " ";" JAVACFLAGS "${JAVACFLAGS}")
add_custom_command(OUTPUT ${JAVA_CLASSES}
  DEPENDS ${JAVA_SOURCES} ${DEPEND_SOURCES}
  COMMAND ${JAVA_COMPILE}
  ARGS ${JAVACFLAGS} -sourcepath ${SRCDIR} -d ${BINDIR} 
    ${CLASSPATH}/VncViewer.java ${JAVA_SOURCES}
	WORKING_DIRECTORY ${SRCDIR})

configure_file(${CLASSPATH}/timestamp.in ${CLASSPATH}/timestamp)

if(NOT "${SRCDIR}" STREQUAL "${BINDIR}")

set(ICONS
tightgatevnc.ico
tightgatevnc.png
insecure.png
secure.png)

foreach(icon ${ICONS})
  add_custom_command(OUTPUT ${BINDIR}/${CLASSPATH}/${icon}
    COMMAND ${CMAKE_COMMAND} -E copy_if_different
      ${SRCDIR}/${CLASSPATH}/${icon} ${BINDIR}/${CLASSPATH}/${icon}
    DEPENDS ${SRCDIR}/${CLASSPATH}/${icon})
endforeach()

endif()

string(REGEX REPLACE "jar" "" Java_PATH ${Java_JAR_EXECUTABLE})
string(REGEX REPLACE ".exe" "" Java_PATH ${Java_PATH})

add_custom_command(OUTPUT VncViewer.jar
  DEPENDS ${JAVA_CLASSES}
    ${SRCDIR}/${CLASSPATH}/MANIFEST.MF
    ${BINDIR}/${CLASSPATH}/timestamp
    ${BINDIR}/${CLASSPATH}/tightgatevnc.ico
    ${BINDIR}/${CLASSPATH}/tightgatevnc.png
    ${BINDIR}/${CLASSPATH}/insecure.png
    ${BINDIR}/${CLASSPATH}/secure.png
  COMMAND ${JAVA_ARCHIVE}
  ARGS cfm VncViewer.jar
    ${SRCDIR}/${CLASSPATH}/MANIFEST.MF
    ${CLASSPATH}/timestamp
    ${CLASSPATH}/*.class
    com/tigervnc/rfb/*.class
    com/tigervnc/rdr/*.class
    com/tigervnc/network/*.class
    com/jcraft/jzlib/*.class
    com/jcraft/jsch/jcraft/*.class
    com/jcraft/jsch/jce/*.class
    com/jcraft/jsch/*.class
    com/tigervnc/vncviewer/*.png
    com/tigervnc/vncviewer/tightgatevnc.ico
  COMMAND ${CMAKE_COMMAND}
  ARGS -DJava_PATH=${Java_PATH} -DJAR_FILE=${BINDIR}/VncViewer.jar
    -DJAVA_KEYSTORE=${JAVA_KEYSTORE}
    -DJAVA_KEYSTORE_TYPE=${JAVA_KEYSTORE_TYPE}
    -DJAVA_STOREPASS=${JAVA_STOREPASS}
    -DJAVA_KEYPASS=${JAVA_KEYPASS}
    -DJAVA_KEY_ALIAS=${JAVA_KEY_ALIAS}
    -DJAVA_TSA_URL=${JAVA_TSA_URL}
    -P ${SRCDIR}/cmake/SignJar.cmake)

add_custom_target(java ALL DEPENDS VncViewer.jar)

=== tests/CMakeLists.txt ===
# Benchmarking tools
#add_subdirectory(perf)

# Unit tests
add_subdirectory(unit)

=== unix/CMakeLists.txt ===
add_subdirectory(tx)
add_subdirectory(common)
add_subdirectory(vncconfig)
#add_subdirectory(vncpasswd)
add_subdirectory(vncserver)
#add_subdirectory(x0vncserver)

=== common/rdr/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/common ${ZLIB_INCLUDE_DIRS})

add_library(rdr STATIC
  BufferedInStream.cxx
  Exception.cxx
  FdInStream.cxx
  FdOutStream.cxx
  HexInStream.cxx
  HexOutStream.cxx
  OutStream.cxx
  MultiInStream.cxx
  MultiOutStream.cxx
  RandomStream.cxx
  TLSException.cxx
  TLSInStream.cxx
  TLSOutStream.cxx
  ZlibInStream.cxx
  ZlibOutStream.cxx)

set(RDR_LIBRARIES ${ZLIB_LIBRARIES} os)
if(GNUTLS_FOUND)
  set(RDR_LIBRARIES ${RDR_LIBRARIES} ${GNUTLS_LIBRARIES})
endif()
if(WIN32)
	set(RDR_LIBRARIES ${RDR_LIBRARIES} ws2_32 dbghelp)
else()
	set(RDR_LIBRARIES ${RDR_LIBRARIES} pthread)
endif()

find_library(MPRIVACY_LIBRARY
  NAMES mprivacy libmprivacy)

target_link_libraries(rdr ${RDR_LIBRARIES} ${MPRIVACY_LIBRARY} "-lzstd")

if(UNIX)
  libtool_create_control_file(rdr)
endif()

=== common/rfb/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/common ${JPEG_INCLUDE_DIR} ${PIXMAN_INCLUDE_DIR})

set(RFB_SOURCES
  Blacklist.cxx
  Congestion.cxx
  CConnection.cxx
  CMsgHandler.cxx
  CMsgReader.cxx
  CMsgWriter.cxx
  CSecurityPlain.cxx
  CSecurityStack.cxx
  CSecurityKrb.cxx
  CSecurityMulti.cxx
  ../../vncviewer/MagicUrlHelper.cxx
  ../../vncviewer/CAutotransferHandler.cxx
  ../../vncviewer/PrintDialog.cxx
  CSecurityVeNCrypt.cxx
  CSecurityVncAuth.cxx
  CWebcamHandler.cxx
  ClientParams.cxx
  ComparingUpdateTracker.cxx
  Configuration.cxx
  CopyRectDecoder.cxx
  Cursor.cxx
  DecodeManager.cxx
  Decoder.cxx
  d3des.c
  EncodeManager.cxx
  Encoder.cxx
  HextileDecoder.cxx
  HextileEncoder.cxx
  JpegCompressor.cxx
  JpegDecompressor.cxx
  MPCompressor.cxx
  MPDecompressor.cxx
  KeyRemapper.cxx
  LogWriter.cxx
  Logger.cxx
  Logger_file.cxx
  Logger_stdio.cxx
  Password.cxx
  PixelBuffer.cxx
  PixelFormat.cxx
  RREEncoder.cxx
  RREDecoder.cxx
  RawDecoder.cxx
  RawEncoder.cxx
  Region.cxx
  SConnection.cxx
  SMsgHandler.cxx
  SMsgReader.cxx
  SMsgWriter.cxx
  ServerCore.cxx
  ServerParams.cxx
  Security.cxx
  SecurityServer.cxx
  SecurityClient.cxx
  SSecurityPlain.cxx
  SSecurityCert.cxx
  SSecurityMulti.cxx
  SSecurityStack.cxx
  SSecurityVncAuth.cxx
  SSecurityVeNCrypt.cxx
  ScaleFilters.cxx
  Timer.cxx
  TightDecoder.cxx
  TightEncoder.cxx
  TightJPEGEncoder.cxx
  TightMPEncoder.cxx
  UpdateTracker.cxx
  VNCSConnectionST.cxx
  VNCServerST.cxx
  ZRLEEncoder.cxx
  ZRLEDecoder.cxx
  encodings.cxx
  util.cxx)

if (NOT APPLE)
  if (NOT WIN32)
    set(RFB_SOURCES ${RFB_SOURCES} SAutotransferDirWatcher.cxx)
    set(RFB_SOURCES ${RFB_SOURCES} SAutotransferNow.cxx)
    set(RFB_SOURCES ${RFB_SOURCES} SAutotransferMime.cxx)
    set(RFB_SOURCES ${RFB_SOURCES} SAutotransferOpswat.cxx)
    set(RFB_SOURCES ${RFB_SOURCES} SAutotransferVaithex.cxx)
  endif()
  set(RFB_SOURCES ${RFB_SOURCES} SWebcamHandler.cxx)
  set(RFB_SOURCES ${RFB_SOURCES} ../../vncviewer/printing.cxx)
  set(RFB_SOURCES ${RFB_SOURCES} SSecurityKrb.cxx)
endif()

if(UNIX)
  set(RFB_SOURCES ${RFB_SOURCES} Logger_syslog.cxx)
endif()

if(WIN32)
  include_directories(${CMAKE_SOURCE_DIR}/win)
  set(RFB_SOURCES ${RFB_SOURCES} WinPasswdValidator.cxx)
endif(WIN32)

if(WIN32)
  set(RFB_LIBRARIES "-Wl,-Bstatic ${JPEG_LIBRARIES} ${PIXMAN_LIBRARY} ${MP_LIBRARIES} -Wl,-Bdynamic" os rdr "-Wl,-Bstatic -lgsasl -lidn -lntlm -lsecur32 -liconv -Wl,-Bdynamic")
else()
  set(RFB_LIBRARIES ${JPEG_LIBRARIES} ${PIXMAN_LIBRARY} ${MP_LIBRARIES} os rdr "-lkrb5 -lk5crypto -lkrb5support -lgssapi_krb5 -lgsasl -lidn -lntlm")
endif()

if(UNIX)
  set(RFB_LIBRARIES ${RFB_LIBRARIES} "-lmprivacy -lmagic -lcurl -lopenh264 -lzstd -larchive")
  if(APPLE)
    set(RFB_LIBRARIES ${RFB_LIBRARIES} "-lgio-2.0 -lgobject-2.0 -lgmodule-2.0 -lglib-2.0 -lpcre -lffi")
  else()
    set(RFB_LIBRARIES ${RFB_LIBRARIES} "-lunistring -lidn2 -lgnutls -lcap -lgio-2.0 -lglib-2.0 -lpcre2-8 -lmount -lffi -lblkid -luuid -lbrotlidec -lbrotlienc -lbrotlicommon -lhwy -llcms2 -ljxl -ljxl_threads")
  endif()
else()
  set(RFB_LIBRARIES ${RFB_LIBRARIES} "-Wl,-Bstatic -lmprivacy -lopenh264 -lzstd -ljxl -llcms2 -lhwy -lbrotlidec -lbrotlicommon -lversion -Wl,-Bdynamic")
endif()

if(UNIX AND NOT APPLE)
  set(RFB_SOURCES ${RFB_SOURCES} UnixPasswordValidator.cxx
    UnixPasswordValidator.h pam.c pam.h)
  set(RFB_LIBRARIES ${RFB_LIBRARIES} ${PAM_LIBS})
endif()

if(GNUTLS_FOUND)
  set(RFB_SOURCES
    ${RFB_SOURCES}
    CSecurityTLS.cxx
    SSecurityTLS.cxx
  )
  set(RFB_LIBRARIES
    ${RFB_LIBRARIES}
    ${GNUTLS_LIBRARIES}
  )
endif()

add_library(rfb STATIC ${RFB_SOURCES})

target_link_libraries(rfb ${RFB_LIBRARIES})

if(UNIX)
  libtool_create_control_file(rfb)
endif()

=== tests/perf/CMakeLists.txt ===
include_directories(${FLTK_INCLUDE_DIR})
include_directories(${GETTEXT_INCLUDE_DIR})

include_directories(${CMAKE_SOURCE_DIR}/common)

add_library(test_util STATIC util.cxx)

add_executable(convperf convperf.cxx)
target_link_libraries(convperf test_util rfb)

set(FBPERF_SOURCES
  fbperf.cxx
  ${CMAKE_SOURCE_DIR}/vncviewer/PlatformPixelBuffer.cxx
  ${CMAKE_SOURCE_DIR}/vncviewer/Surface.cxx)
if(WIN32)
  set(FBPERF_SOURCES ${FBPERF_SOURCES} ${CMAKE_SOURCE_DIR}/vncviewer/Surface_Win32.cxx)
elseif(APPLE)
  set(FBPERF_SOURCES
      ${FBPERF_SOURCES} ${CMAKE_SOURCE_DIR}/vncviewer/Surface_OSX.cxx
      ${FBPERF_SOURCES} ${CMAKE_SOURCE_DIR}/vncviewer/keysym2ucs.c
      ${FBPERF_SOURCES} ${CMAKE_SOURCE_DIR}/vncviewer/cocoa.mm)
else()
  set(FBPERF_SOURCES ${FBPERF_SOURCES} ${CMAKE_SOURCE_DIR}/vncviewer/Surface_X11.cxx)
endif()
add_executable(fbperf ${FBPERF_SOURCES})
target_link_libraries(fbperf test_util rfb ${FLTK_LIBRARIES} ${GETTEXT_LIBRARIES})
if(WIN32)
  target_link_libraries(fbperf msimg32)
endif()
if(APPLE)
  target_link_libraries(fbperf "-framework Cocoa")
  target_link_libraries(fbperf "-framework Carbon")
  target_link_libraries(fbperf "-framework IOKit")
endif()

=== tests/unit/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/common)
include_directories(${CMAKE_SOURCE_DIR}/vncviewer)

add_executable(conv conv.cxx)
target_link_libraries(conv rfb)

add_executable(convertlf convertlf.cxx)
target_link_libraries(convertlf rfb)

#add_executable(gesturehandler gesturehandler.cxx ../../vncviewer/GestureHandler.cxx)
#target_link_libraries(gesturehandler rfb)

add_executable(hostport hostport.cxx)
target_link_libraries(hostport rfb)

add_executable(pixelformat pixelformat.cxx)
target_link_libraries(pixelformat rfb)

add_executable(unicode unicode.cxx)
target_link_libraries(unicode rfb)

add_executable(emulatemb emulatemb.cxx ../../vncviewer/EmulateMB.cxx)
target_link_libraries(emulatemb rfb  ${GETTEXT_LIBRARIES})

=== unix/vncpasswd/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/common)

add_executable(vncpasswd 
  vncpasswd.cxx ../../vncviewer/parameters.cxx)

target_link_libraries(vncpasswd tx rfb os "-lzstd")

install(TARGETS vncpasswd DESTINATION ${CMAKE_INSTALL_FULL_BINDIR})
install(FILES vncpasswd.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man1 RENAME vncpasswd.1)

=== unix/vncserver/CMakeLists.txt ===
add_executable(vncsession vncsession.c)
target_link_libraries(vncsession ${PAM_LIBS} "-lc")

configure_file(vncserver@.service.in vncserver@.service @ONLY)
configure_file(vncsession-start.in vncsession-start @ONLY)
configure_file(vncserver.in vncserver @ONLY)
configure_file(vncsession.man.in vncsession.man @ONLY)

install(TARGETS vncsession DESTINATION ${CMAKE_INSTALL_FULL_SBINDIR})
install(FILES tigervnc.pam DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d RENAME tigervnc)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/vncsession.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man8 RENAME vncsession.8)
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/vncserver DESTINATION ${CMAKE_INSTALL_FULL_LIBEXECDIR})
install(FILES vncserver.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man8 RENAME vncserver.8)
install(FILES vncserver-config-defaults vncserver-config-mandatory DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/tigervnc)

install(FILES vncserver.users DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/tigervnc)

install(FILES HOWTO.md DESTINATION ${CMAKE_INSTALL_FULL_DOCDIR})

if(INSTALL_SYSTEMD_UNITS)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/vncserver@.service DESTINATION ${CMAKE_INSTALL_FULL_UNITDIR})
  install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/vncsession-start DESTINATION ${CMAKE_INSTALL_FULL_LIBEXECDIR})
endif()

=== debian/changelog ===
tightgatevnc-clientonly (4.8.0~aatgv2) testing; urgency=low

  * git (rebase-20210322-4.8) 0f362ba5fbe9c5ea93695d0960c206c051db908f
    BUG 0007257: Cursor-Einstellung an VNC-Klienten konfigurierbar machen
    Add bool parameter AllowLocalCursor with default 1 to control the
      "supportsLocalCursor" value at the client side. Setting to 0 lets the
      server render all cursors.
  * git (rebase-20210322-4.8) 5be245fe1565bfcf92839a64a093e44b81aaa7b3
    Fix Windows builds with GCC 15.
  * git (rebase-20210322-4.8) 58dc8394ccaa0f8580075afeb53195bd0b906d74
    BUG 0007261: MagicURL - Möglichkeit ("Schalter") um trotz Whitelist-Pfad lokale Whitelisten zu erlauben
    Actually from magicurl-win (commit 31b1c91f62b3f64c3a81832a3a145b7dd598c20c).
    Also implementing here as at some point, magicurl will
    be integrated into the tightgateviewer.
    Read 'force_whitelist_path' option from browserchoice.cfg.
    force_whitelist_path only makes sense if whitelist_path is set.
    If so, setting force_whitelist_path to 0 would allow to read
    the other "standard" URL whitelist files. If set to 1 (default)
    it will only read the whitelist found in whiteliste_path. If it
    doesn't find it, it exits and shows an error.
  * git (rebase-20210322-4.8) 42526481d787d6a1317b454cd7d6f577e852115d
    BUG 0007261: MagicURL - Möglichkeit ("Schalter") um trotz Whitelist-Pfad lokale Whitelisten zu erlauben
    UrlWhitelistHandler: Set force_whitelist_path's default to 0/false.
  * git (rebase-20210322-4.8) fd6f0f6c69ce17cedbf8619955d1a4863942f44c
    SSecurityKrb: Remove test (not even alpha) code that slipped in a commit.
  * git (rebase-20210322-4.8) d649ad7cc5b0f7f4542016a6dab05c769970f7d5
    BUG 0007222: Autoschleuse (VNC) protokolliert nicht "Anonym"
    SAutotransferMime: Add resolve_username_for_logs and
    replace_username_dir(filename, new_username) and call them before
    creating log line.
  * git (rebase-20210322-4.8) 5066f40585827470d82ac7b725e88c04170fe923
    SAutotransferMime: Surroung complete file with
     #if !defined(WIN32) && !defined(WIN64) && !defined(__APPLE__).
    We really just need it for the server - only Linux.
  * git (rebase-20210322-4.8) 09c1ad540c691d75d6a34648128d704474839eae
    SAutotransferMime: Move resolve_username_for_logs and
    replace_username_dir_for_logs to libmprivacy and use it from there.
    Note: I hope to be able to move the whole logging function there
    so that sfpt-server and SAutotransferMime can share it.
  * git (rebase-20210322-4.8) 8f36b393a13e463bbd75b6b73422ccde4be755e1
    Simplify LDAP logic: Don't force ldap base to 'auto' and just run
    generate_ldap_base when necessary. Also better error handling for
    generate_ldap_base call.
  * git (rebase-20210322-4.8) d7dd66831bc8893e7f3c9066f7b07b9382437ea3
    Simplify LDAP logic: Remove ldap_server_1 and ldap_server_2
    (since they were always forced to "auto" and "").
  * git (rebase-20210322-4.8) c4d9cf69428bd04277547130f75c78adfe04dad9
    Simplify LDAP logic: Remove ldap_auto code (since it was always
    being forced to "realm").
  * git (rebase-20210322-4.8) 0caaf37a5d22278f506b2def333409ee20fe04cf
    Simplify LDAP logic: Call perform_ldap_searches with NULL where
    no value is actually used.
  * git (rebase-20210322-4.8) 29c47e25779ffd02f87d6cfd06c14a1b13db5f72
    Define macros likely(x) and unlikely(x) for GCC and annotate MP en/decoder.
  * git (rebase-20210322-4.8) 1f060ba696c4b9451df2d1155d8bec1fc0a41025
    MP.h: Remove bogus (x) after #ifndef.

 -- Amon Ott <ao@m-privacy.de>  Wed, 10 Sep 2025 11:00:00 +0200

tightgatevnc-clientonly (4.8.0~aatgv1) testing; urgency=low

  * Switch to branch rebase-20210322-4.8 at
    git 4ec22ea307d75d4e37f0311f221b29ffa4691150
    BUG 0006982: Druckdialog im Viewer skaliert nicht
    pdfprinter: Big refactor that uses printdlgex. This makes it look
    much better (at least on Windows 11).
  * Build with Debian bookworm
  * Add compile flag -Wno-error=stringop-overread

 -- Amon Ott <ao@m-privacy.de>  Wed, 10 Sep 2025 10:29:00 +0200

=== debian/control ===
Source: tightgatevnc-clientonly
Section: x11
Priority: optional
Maintainer: m-privacy GmbH (<info@m-privacy.de>)
Build-Depends: debhelper (>= 4.0.0), perl, gcc, g++, sed,
 libgettextpo-dev, cmake, libxft-dev, libcap-dev, libaudit-dev,
 libxinerama-dev, libpng-dev, libfltk1.3-dev,
 libturbojpeg0-dev, libjpeg62-turbo-dev, zlib1g-dev, automake1.9 | automake1.11, autoconf,
 xserver-xorg-dev, xutils, pkg-config,
 x11proto-core-dev (>= 7.0.26),
 x11proto-kb-dev (>= 1.0.1-1), x11proto-xinerama-dev,
 x11proto-randr-dev (>= 1.4.0), x11proto-record-dev, x11proto-render-dev,
 x11proto-scrnsaver-dev, x11proto-video-dev,
 x11proto-xext-dev (>= 7.2.99.901),
 x11proto-xf86dga-dev,
 x11proto-xf86vidmode-dev, xtrans-dev (>= 1.3.3), libxau-dev (>= 1:0.1.2-1),
 libxdmcp-dev (>= 1:0.1.3-2), libxfont-dev (>= 2), libfontenc-dev,
 libxkbfile-dev (>= 7.0.0-1), x11proto-xf86dri-dev, libdrm-dev (>> 2.0),
 x11proto-gl-dev (>= 1.4.1-1), libgl1-mesa-dev (>= 7.8.0), libxmuu-dev (>= 1:1.0.2-2),
 libxext-dev (>= 1:1.0.1-2), libx11-dev (>= 1:6.2.1+cvs.20050722-1),
 libxrender-dev (>= 1:0.9.0-1), libxi-dev (>= 1:1.0.1-4),
 dpatch, libdmx-dev, libxpm-dev (>= 1:3.5.3-1), libxaw7-dev (>= 1:1.0.2-4),
 libxt-dev (>> 1:0.99.3+cvs.20051212), libxmu-dev (>= 1:1.0.2-2),
 libxtst-dev (>= 1:1.0.1-5), libxres-dev (>= 1:1.0.2+0.99.1-1),
 libfreetype6-dev, flex, dpatch, gnutls28-nop11-dev | libgnutls28-dev, nasm, libtool,
 x11proto-gl-dev, libpciaccess-dev, libexpat1-dev, cvs,
 libpam0g-dev, autopoint, xutils-dev, x11proto-fonts-dev (>= 2.1.3),
 x11proto-input-dev (>= 2.3), x11proto-dri2-dev, libxxf86vm-dev, libxfixes-dev,
 libsm-dev, libice-dev, libpixman-1-dev, libxdamage-dev, libglu1-mesa-dev,
 libosmesa6-dev, mesa-common-dev, libpthread-stubs0-dev,
 xfonts-utils (>= 7.5), libgcrypt-dev, libgsasl7-dev (>= 1.8.0),
 libgsasl7-dev (<< 1.8.0-3),
 libmprivacy (>= 1.0.55+aatgv1), libtasn1-6-dev, nettle-dev,
 libkrb5support0-static | libkrb5-dev, libkrb5-static-3 | libkrb5-dev, libgssapi-krb5-static-2 | libkrb5-dev,
 libkeyutils-dev, librsvg2-bin, libxcursor-dev, libbz2-dev,
 libc6-dev, libssh-dev, libnacl-dev, libcurl4-gnutls-dev,
 x11proto-present-dev, libb64-dev, fluid, libjemalloc-dev, libmagic-dev, rename,
 libglib2.0-dev, libmount-dev, libunistring-dev, libidn2-dev,
 libopenh264-dev (>= 2.3.1-2), libzstd-dev, libwebp-dev, libbrotli-dev,
 nlohmann-json3-dev, libunwind-dev,
 comerr-dev, libjxl-dev,
 libarchive-dev, gettext-base, librsbac-dev
Build-Conflicts: libc6 (>= 2.37)
Standards-Version: 3.6.1

Package: tightgateviewer
Section: net
Architecture: any
Provides: vnc-viewer
Replaces: xvnc4viewer, tigervncviewer
Depends: libc6 (>> 2.31), ${shlibs:Depends}
Conflicts: tightgateviewer-internal
Recommends: gstreamer1.0-tools, daemon, v4l-utils, ffmpeg
Suggests: tightgatevnc-common
Description: TightGate-Pro VNC client
 VNC stands for Virtual Network Computing. It is, in essence, a remote
 display system which allows you to view a computing `desktop' environment
 not only on the machine where it is running, but from anywhere on the
 Internet and from a wide variety of machine architectures.
 .
 It is implemented in a client/server model. This package provides a vncclient
 for X, with this you can connect to a vncserver somewhere in the network
 and display its content in a window. There are vncserver available for X
 and for Win95/NT.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

#DEB_HOST_MULTIARCH =

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

#export http_proxy=http://192.168.8.254:3130
export no_proxy="localhost"
export ftp_proxy=http://192.168.8.254:3138

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
#DEB_HOST_GNU_TYPE   = i686-linux-gnu
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
#DEB_BUILD_GNU_TYPE  = $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)


# original
#export CFLAGS = -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export SERVERCFLAGS = -Wall -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export CXXFLAGS = -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -std=gnu++0x -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export LDFLAGS = -Wl,--as-needed -Wl,--allow-multiple-definition -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=stringop-overread

# GCC 8 / Buster
#export CFLAGS = -lzstd -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -march=x86-64-v2 -mtune=generic -fno-lto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr
#export SERVERCFLAGS = -lzstd -Wall -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -march=x86-64-v2 -mtune=generic -fno-lto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr
#export CXXFLAGS = -lzstd -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -std=gnu++0x -march=x86-64-v2 -mtune=generic -fno-lto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr
#export LDFLAGS = -lzstd -Wl,--as-needed -Wl,--allow-multiple-definition -march=x86-64-v2 -mtune=generic -fno-lto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr
# Buster with lto
#export CFLAGS = -lzstd -Wall -Werror -g -O3 -Wl,-z,lazy -D_GLIBCXX_ASSERTIONS -fstack-clash-protection -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -march=x86-64-v2 -mtune=generic -flto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr
#export SERVERCFLAGS = -lzstd -Wall -g -O3 -Wl,-z,lazy -D_GLIBCXX_ASSERTIONS -fstack-clash-protection -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -march=x86-64-v2 -mtune=generic -flto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr
#export CXXFLAGS = -lzstd -Wall -Werror -g -O3 -Wl,-z,lazy -D_GLIBCXX_ASSERTIONS -fstack-clash-protection -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -std=gnu++0x -march=x86-64-v2 -mtune=generic -flto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr
#export LDFLAGS = -lzstd -lunistring -Wl,--as-needed -Wl,--allow-multiple-definition -march=x86-64-v2 -mtune=generic -flto -ffat-lto-objects -fPIE -D_GLIBCXX_ASSERTIONS -fstack-clash-protection -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr
# Bookworm really with lto
export CFLAGS = -lzstd -Wall -Werror -g -O3 -Wl,-z,lazy -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects -D_GLIBCXX_ASSERTIONS -fstack-clash-protection -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -march=x86-64-v2 -mtune=generic -flto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
export SERVERCFLAGS = -lzstd -Wall -g -O3 -Wl,-z,lazy -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects -D_GLIBCXX_ASSERTIONS -fstack-clash-protection -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -march=x86-64-v2 -mtune=generic -flto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
export CXXFLAGS = -lzstd -Wall -Werror -g -O3 -Wl,-z,lazy -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects -D_GLIBCXX_ASSERTIONS -fstack-clash-protection -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -std=gnu++0x -march=x86-64-v2 -mtune=generic -flto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
export LDFLAGS = -lzstd -lunistring -Wl,--as-needed -Wl,--allow-multiple-definition -march=x86-64-v2 -mtune=generic -flto -ffat-lto-objects -fPIE -D_GLIBCXX_ASSERTIONS -fstack-clash-protection -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects

#export CFLAGS = -nolibc -static-pie -lc -lgcc -lunwind -llzma -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export SERVERCFLAGS = -nolibc -static-pie -lc -lgcc -lunwind -llzma -Wall -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export CXXFLAGS = -nolibc -static-pie -lc -lgcc -lunwind -llzma -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -std=gnu++0x -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export LDFLAGS = -nolibc -static-pie -lc -lgcc -lunwind -llzma -Wl,--as-needed -Wl,--allow-multiple-definition -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=stringop-overread
#export CFLAGS = -nodefaultlibs -static-pie -lc -lm -lgcc -lgcc_eh -lunwind -llzma -ldl -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
